/*   
    
    Ec  Vers  4.1-0    Copyright (C)   2001 Marc Dechico

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: Marc.DECHICO@wanadoo.fr
    
*/

#include "ec_data.h"
/*****************************************************************************/
/* calcul direction pour un ventuel echec par demasquage                    */
/*****************************************************************************/

void ech_cal_dir_dem	(int i_cam_roi,int *pi_ech_dir_dem)
{
  /* oti : voir si retour paramtre plus rapide que passage par adresse */
int nr;     /* coordonne roi 	 	*/
  int Id_r;   /* Id du roi 	        */

  Id_r=Id_roi[i_cam_roi];
  nr = (tpts_pie[i_cam_roi]+Id_r)->i_pos_n;

  *pi_ech_dir_dem = ts_ech_par[pts_hst_pro->i_pos_ori_n][nr].i_ech_dir_rei;	
 
}
void ech_cal_dir_dem_ca	(void)
{
  pts_hst_pro->i_ech_dir_dem =
    ts_ech_par[pts_hst_pro->i_pos_ori_n][pts_hst_pro->i_pos_n_R_c_a].i_ech_dir_rei;	 
}
void ech_cal_dir_dem_pc	(void)
{
  pts_hst_pro->i_ech_dir_dem_p_c =
    ts_ech_par[pts_hst_pro->i_pos_ori_n][pts_hst_pro->i_pos_n_R_p_c].i_ech_dir_rei;	 
}
int ech_cal_dir_dem_2	(int i_cam_roi,int i_pos_n)
{
  /* oti : voir si retour paramtre plus rapide que passage par adresse */
  int nr;     /* coordonne roi 	 	*/
  int Id_r;   /* Id du roi 	        */

  Id_r=Id_roi[i_cam_roi];
  nr = (tpts_pie[i_cam_roi]+Id_r)->i_pos_n;
  pts_hst_pro->i_ech_dir_pri =ts_ech_par[i_pos_n][nr].i_ech_dir_rei;
  return  	 pts_hst_pro->i_ech_dir_pri;
 
}

/****************************************************************************/
/* Verifie si une piece met le roi echec                                    */
/****************************************************************************/

int ech_par_rei 	(int nd,int nr)
{
  int n;
  int inc;

 
  if ( ts_ech_par[nd][nr].i_ech_dir_rei)
    {
      inc=ts_ech_par[nd][nr].i_inc;
      pts_hst_pro->i_ech_dir_pri = ts_ech_par[nd][nr].i_ech_dir_rei; 

      for (n=nr+inc; n!=nd ;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0)
	    { 
	      pts_hst_pro->i_ech_dir_pri = 0; 
	      return  pts_hst_pro->i_ech_dir_pri;	
	    }
	}
      return  pts_hst_pro->i_ech_dir_pri; 
    }
  else
    {
      pts_hst_pro->i_ech_dir_pri =0;
      return  pts_hst_pro->i_ech_dir_pri;
    }
}
/* echec par la tour */
int ech_par_tou 	(int nt,int nr)
{
  int n;
  int inc;
	
  if ( ts_ech_par[nt][nr].i_ech_dir_tou)
    {
      inc=ts_ech_par[nt][nr].i_inc;
      pts_hst_pro->i_ech_dir_pri = ts_ech_par[nt][nr].i_ech_dir_tou; 
      for (n=nr+inc; n!=nt;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0) 
	    {
	      pts_hst_pro->i_ech_dir_pri = 0; 
	      return pts_hst_pro->i_ech_dir_pri;
	    }
	}
      return pts_hst_pro->i_ech_dir_pri; 
    }
  else
    {
      pts_hst_pro->i_ech_dir_pri =0;
      return pts_hst_pro->i_ech_dir_pri;
    }
}

/* echec par le fou  */
int ech_par_fou 	(int nf,int nr)
{
  int n;
  int inc;

  if ( ts_ech_par[nf][nr].i_ech_dir_fou)
    {
      inc=ts_ech_par[nf][nr].i_inc;
      pts_hst_pro->i_ech_dir_pri = ts_ech_par[nf][nr].i_ech_dir_fou; 

      for (n=nr+inc; n!=nf;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0) 
	    {
	       pts_hst_pro->i_ech_dir_pri =0;
	       return  pts_hst_pro->i_ech_dir_pri;
	   }
	}
      return  pts_hst_pro->i_ech_dir_pri; 
    }
  else
    {
      pts_hst_pro->i_ech_dir_pri =0;
      return  pts_hst_pro->i_ech_dir_pri;
    }
}
/* echec par le  cavalier */
int ech_par_cav 	(int nc,int nr)
{
 
  pts_hst_pro->i_ech_dir_pri = ts_ech_par[nc ][nr ].i_ech_dir_cav;	
  return  pts_hst_pro->i_ech_dir_pri;
}
/* echec par le  cavalier */
int ech_par_roi 	(int n, int nr)
{
 
  pts_hst_pro->i_ech_dir_pri = ts_ech_par[n ][ nr ].i_ech_dir_roi;	
  return  pts_hst_pro->i_ech_dir_pri;
}

/* echec par pion couleur blanc */
int ech_par_pio_0 	(int np, int nr)
{
  pts_hst_pro->i_ech_dir_pri = ts_ech_par[np ][nr ].i_ech_dir_pio_bla;	
  return pts_hst_pro->i_ech_dir_pri;
}
/* echec par pion couleur noir */
int ech_par_pio_1 	(int np, int nr)
{  
  pts_hst_pro->i_ech_dir_pri = ts_ech_par[ np ][nr ].i_ech_dir_pio_noi;	
  return pts_hst_pro->i_ech_dir_pri;
}

/**********************************************************************************/
/* Controle si case sous controle d'une certaine piece                            */
/**********************************************************************************/

int ctl_par_rei 	(int nd,int nr)
{
		
  int n;
  int inc;

 
  if ( ts_ech_par[nd][nr].i_ech_dir_rei)
    {
      inc=ts_ech_par[nd][nr].i_inc;
      for (n=nr+inc; n!=nd ;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0)
	    { 
	      return  0;	
	    }
	}
     return  1; 
    }
  else
    {
      return  0;
    }
}
/* echec par la tour */
int ctl_par_tou 	(int nt,int nr)
{
  int n;
  int inc;
	
  if ( ts_ech_par[nt][nr].i_ech_dir_tou)
    {
      inc=ts_ech_par[nt][nr].i_inc;
 
      for (n=nr+inc; n!=nt;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0) 
	    {
	      return 0;
	    }
	}
      return 1; 
    }
  else
    {
      return 0;
    }
}

/* echec par le fou  */
int ctl_par_fou 	(int nf,int nr)
{
		
  int n;
  int inc;

  if ( ts_ech_par[nf][nr].i_ech_dir_fou)
    {
      inc=ts_ech_par[nf][nr].i_inc;
      for (n=nr+inc; n!=nf;n+=inc)
	{ 
	  if (ts_ech[n].i_cam >=0) 
	    {
		return  0;
	   }
	}
      return  1; 
    }
  else
    {
       return  0;
    }
}
/* echec par le  cavalier */
int ctl_par_cav 	(int nc,int nr)
{
  return ts_ech_par[nc ][nr ].i_ech_dir_cav;	
}
/* echec par le  cavalier */
int ctl_par_roi 	(int n, int nr)
{
  return  ts_ech_par[n ][ nr ].i_ech_dir_roi;	
}

/* echec par pion couleur blanc */
int ctl_par_pio_0 	(int np, int nr)
{
 return  ts_ech_par[np ][nr ].i_ech_dir_pio_bla;	
 
}
/* echec par pion couleur noir */
int ctl_par_pio_1 	(int np, int nr)
{  
  return  ts_ech_par[ np ][nr ].i_ech_dir_pio_noi;	
}


int ctl_par_xxx (int nn)
{
  struct st_pie *pts_pie_ct;
   
  for (pts_pie_ct= pts_hst_pro->pts_pie_ca+ pts_hst_pro->pts_pie_ca->i_pie_sui;
       ;
       pts_pie_ct= pts_hst_pro->pts_pie_ca +pts_pie_ct->i_pie_sui)
  
    {
      /* il ya toujours au moins une piece presente par camp: le roi  */
      if(   (*pts_pie_ct->pf_ctl_par) (pts_pie_ct->i_pos_n,nn )   )
	{
	  return 1;
	} 
      if (pts_pie_ct->i_pie_sui==17) break;

    }
  return 0;
}

/*****************************************************************************************/
/* fct  case sous controle adversaire  selon une direction donnee                        */
/*****************************************************************************************/
int cas_ctl_nul     (int n,int i_cam_adv)
{
  n=0;
  i_cam_adv=0;
  return 0;
}

/* oblique: fou et reine */
int cas_ctl_h_d     (int n,int i_cam_adv)
{

  int i_cam_pie;
  
  for(;;)
    {
      n HD;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{

	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_fou)   	/* renne ou fou */
	    {
	      return 1;
	    }

	  else                 /* piece averse ne pouvant provoquer echec */
	    {
	      return 0;
	    }
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}

    }

}
int cas_ctl_h_g     (int n,int i_cam_adv)
{
  int i_cam_pie;

  for(;;)
    {
     n HG;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_fou)   	/* renne ou fou */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}
    }


}
int cas_ctl_b_d     (int n,int i_cam_adv)
{
  int i_cam_pie;

  for(;;)
    {
      n BD;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_fou)   	/* renne ou fou */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}
    }

}
int cas_ctl_b_g     (int n,int i_cam_adv)
{
  int i_cam_pie;

  for(;;)
    {
      n BG;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_fou)   	/* renne ou fou */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}

    }


}
/* droite  tour et reine */
int cas_ctl_h     (int n,int i_cam_adv)
{
  int i_cam_pie;
  for(;;)
    {
      n HH;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_tou)   	/* renne ou toure */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}
    }

}
int cas_ctl_b     (int n,int i_cam_adv)
{
  int i_cam_pie;

  for(;;)
    {
      n BB;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_tou)   	/* renne ou toure */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}

    }

}
int cas_ctl_d     (int n,int i_cam_adv)
{
  int i_cam_pie;

  for(;;)
    {
      n DD;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_tou)   	/* renne ou toure */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}

    }
}
int cas_ctl_g     (int n,int i_cam_adv)
{
  int i_cam_pie;
  for(;;)
    {
      n GG;
      i_cam_pie = ts_ech[n].i_cam;

      if(i_cam_pie == i_cam_adv)				/* pice adverse */
	{
	  if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->i_typ_mvt_tou)   	/* renne ou toure */
	    return 1;

	  else                 /* piece averse ne pouvant provoquer echec */
	    return 0;
	}
      else       					/* piece propre camp ou hors limite */
	{
	  if (i_cam_pie != VIDE)
	    return 0;
	}

    }
}
/* cavalier haut droit*/
int cas_ctl_cav_h_d     (int n,int i_cam_adv)
{
  n CHD;

  if  (
         ts_ech[n].i_cam== i_cam_adv				/* pice adverse */
         &&
         (tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C'   /* cav */
      )
     return 1;
  else  
     return 0;
}
/* cavalier droite haut*/
int cas_ctl_cav_d_h     (int n,int i_cam_adv)
{
  n CDH;

  if(
       ts_ech[n].i_cam == i_cam_adv				/* pice adverse */
       &&
       (tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C'  /* cav */
     )
     return 1;
    else

    return 0;
}
/* cavalier droite bas*/
int cas_ctl_cav_d_b     (int n,int i_cam_adv)
{
  n CDB;
 
  if(ts_ech[n].i_cam == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav*/
	return 1;
    }

  return 0;

}
/* cavalier bas droite*/
int cas_ctl_cav_b_d     (int n,int i_cam_adv)
{
  n CBD;
  if(ts_ech[n].i_cam== i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav  */
	return 1;
    }

  return 0;
}
/* cavalier bas gauche */
int cas_ctl_cav_b_g     (int n,int i_cam_adv)
{
  n CBG;
  /* opti code:  voir ci dessus */ 
  if(ts_ech[n].i_cam == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav */
	return 1;
    }

  return 0;
}
/* cavalier gauche bas*/
int cas_ctl_cav_g_b     (int n,int i_cam_adv)
{
  n CGB;
 
  if(ts_ech[n].i_cam == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav*/
	return 1;
    }

  return 0;
}
/* cavalier gauche haut*/
int cas_ctl_cav_g_h     (int n,int i_cam_adv)
{
  n CGH;
 

  if(ts_ech[n].i_cam == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav*/
	return 1;
    }

  return 0;
}
/* cavalier haut gauche*/
int cas_ctl_cav_h_g     (int n,int i_cam_adv)
{
  n CHG;
 

  if(ts_ech[n].i_cam == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'C')/* cav */
	return 1;
    }

  return 0;

}
/* pion droit */
int cas_ctl_pio_d     (int n,int i_cam_adv)
{
  int i_cam_pie;
  /* mvt du roi vers le pion */ 
  if (i_cam_adv ==NOIR) 		n HD;
  /* camp adverse = 0 */
  else 					n BD;

  /* tst */

  i_cam_pie = ts_ech[n].i_cam;
  if(i_cam_pie == i_cam_adv)				/* pice adverse */
    {
      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'P')/* pion*/
	{
	
	return 1;
	}
    }
  return 0;
}

/* pion gauche */
int cas_ctl_pio_g     (int n,int i_cam_adv)
{
  int i_cam_pie;
  /*mvt du roi vers le pion */
  if (i_cam_adv ==NOIR)			   n HG;
  /* camp adverse = 0 */
  else					   n BG;

  i_cam_pie = ts_ech[n].i_cam;
  if(i_cam_pie == i_cam_adv)				/* pice adverse */
    {

      if((tpts_pie[i_cam_adv] +ts_ech[n].i_Id)->c_typ_pie == 'P')/* pion */
	return 1;
    }
  return 0;
}
